use std::default::Default;

#[derive(Default)]
pub struct MemoryMap {
    pub global:   Vec<Symbol>,
    pub sections: Vec<Section>
}

#[derive(Default)]
pub struct Section {
    pub name:    String,
    pub adr:     u64,
    pub size:    usize,
    pub symbols: Vec<Symbol>
}

impl Section {
    pub fn new(name: String, adr: u64, size: usize) -> Section {
        Section{name, adr, size, symbols: Vec::new()}
    }

    pub fn contains_adr(&self, adr: u64) -> bool {
        adr >= self.adr && adr < (self.adr + self.size as u64)
    }
}

#[derive(Default)]
pub struct Symbol {
    pub name: String,
    pub adr:  u64,
    pub size: usize
}

impl Symbol {
    pub fn new(name: String, adr: u64, size: usize) -> Symbol {
        Symbol{name, adr, size}
    }
}